/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

//package fi.hut.tcm.jacob.tcpip.demo;
import fi.hut.tcm.jacob.tcpip.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class Receiver implements Runnable {
  private TextArea outArea;
  private JacobDatagramSocket socket;
  //  private InetAddress saddr;
  // int sport;
  private byte buffer[];
  private DatagramPacket packet;
  private GameArea gameArea;

  public Receiver(TextArea reportArea, GameArea draw_area, JacobDatagramSocket sockfd) {
    outArea = reportArea;
    socket = sockfd;
    buffer = new byte[20];
    gameArea = draw_area;
  }

  public void run()  {
    String astr;
    int x_pos, y_pos;

    buffer = new byte[20];
    packet = new DatagramPacket(buffer, buffer.length);
    for ( ; ; ) {
      try {
	socket.receive(packet);
      } catch (java.io.IOException io) {
	System.err.println("Error receiving UDP datagram: " + io);
	// Clean up the packet, just in case:
	packet = new DatagramPacket(buffer, buffer.length);
      }
      buffer = packet.getData();
      x_pos = (((int) buffer[0] & 0xff) << 8) | (((int) buffer[1]) & 0xff);
      y_pos = (((int) buffer[2] & 0xff) << 8) | (((int) buffer[3]) & 0xff);

      astr = "\nX=" + x_pos + ", Y=" + y_pos;
      outArea.append(astr);
      gameArea.moveBallTo(x_pos, y_pos);
      // Construct the packet to send:
    }
  }

}
