/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  TcpipRoutingEntry (implementation)
    Package: tcpip
    File:    TcpipRoutingEntry.java


*/
package fi.hut.tcm.jacob.tcpip;
/**
    TcpipRoutingEntry
    
    
*/
public class TcpipRoutingEntry {
    protected int network;
    protected int netmask;
    protected int nexthop;
    protected String interfaceId;
    protected TcpipRoutingEntry next;

    public TcpipRoutingEntry(int network, int netmask, int nexthop, String interfaceId) {
    //+ TcpipRoutingEntry::TcpipRoutingEntry(int, int, int, String)
      this.network = network;
      this.netmask = netmask;
      this.nexthop = nexthop;
      this.interfaceId = interfaceId;
    //- TcpipRoutingEntry::TcpipRoutingEntry(int, int, int, String)
    }

    public int getNetwork() {
    //+ TcpipRoutingEntry::getNetwork( )
      return this.network;
    //- TcpipRoutingEntry::getNetwork( )
    }

    public void setNetwork(int addr) {
    //+ TcpipRoutingEntry::setNetwork(int)
      this.network = addr;
    //- TcpipRoutingEntry::setNetwork(int)
    }

    public int getNetmask() {
    //+ TcpipRoutingEntry::getNetmask( )
      return this.netmask;
    //- TcpipRoutingEntry::getNetmask( )
    }

    public void setNetmask(int mask) {
    //+ TcpipRoutingEntry::setNetmask(int)
      this.netmask = mask;
    //- TcpipRoutingEntry::setNetmask(int)
    }

    public int getNexthop() {
    //+ TcpipRoutingEntry::getNexthop( )
      return this.nexthop;
    //- TcpipRoutingEntry::getNexthop( )
    }

    public void setNexthop(int addr) {
    //+ TcpipRoutingEntry::setNexthop(int)
      this.nexthop = addr;
    //- TcpipRoutingEntry::setNexthop(int)
    }

    public String getInterfaceId() {
    //+ TcpipRoutingEntry::getInterfaceId( )
      return new String(interfaceId);
    //- TcpipRoutingEntry::getInterfaceId( )
    }

    public void setInterfaceId(String id) {
    //+ TcpipRoutingEntry::setInterfaceId(String)
      interfaceId = new String(id);
    //- TcpipRoutingEntry::setInterfaceId(String)
    }

    public void print() {
    //+ TcpipRoutingEntry::print( )
      System.err.println("ROUTING table entry:");
      System.err.println("Network: " +
			 ((network >> 24) & 0xff) + "." +
			 ((network >> 16) & 0xff) + "." +
			 ((network >>  8) & 0xff) + "." +
			 (network & 0xff));
      System.err.println("Netmask: " +
			 ((netmask >> 24) & 0xff) + "." +
			 ((netmask >> 16) & 0xff) + "." +
			 ((netmask >>  8) & 0xff) + "." +
			 (netmask & 0xff));
      System.err.println("Nexthop: " +
			 ((nexthop >> 24) & 0xff) + "." +
			 ((nexthop >> 16) & 0xff) + "." +
			 ((nexthop >>  8) & 0xff) + "." +
			 (nexthop & 0xff));
      System.err.println("Interface id: " + interfaceId);
    //- TcpipRoutingEntry::print( )
    }

}; //TcpipRoutingEntry
