/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**

    File:    EtherAdaptorAccessor.java


*/
package fi.hut.tcm.jacob.tcpip.arp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    EtherAdaptorAccessor
    
    Used to get by limitations in EthernetAdaptor.
*/
public class EtherAdaptorAccessor
  implements Accessor {

    public void setKey(Message message, Object key) {

      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();

      Object buf = message.getContents();
      
      UtilMsgr.i.setShort(buf, 6, ((Integer) key).intValue() );
      oob.setEthFrameType(((Integer) key).intValue());

      if (Arp.DebugLevel > 1) {  // #Debug#
	System.out.println("EtherAdaptorAccessor.setKey: Frame type set to: " +
			   ((Integer) key).intValue() );
      }
    }

    public Object getKey(Message message) {

      Object buf =  message.getContents();

      int frType = UtilMsgr.i.getShort(buf, 6);

      if (Arp.DebugLevel > 1) {  // #Debug#
	System.out.println("EtherAdaptorAccessor.getKey: Frame type is: " + frType);
      }

      return (new Integer(frType));
    }

    public void unsetKey(Message message) {
      // do nothing
    }

}; //ArpSelectorAccessor

