/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  IpChecksumSession
  Package: ip
  File:    IpChecksumSession.java
*/

package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
  IpChecksumSession
  
  1. Calculates the IP header checksum for outgoing packets and forwards 
  them to the IpProtocol conduit.
  2. Checks the checksum for incoming packets. If the checksum is correct, 
  the packet is forwarded to the IpFragmentationSession. Otherwise, the 
  packet is discarded.
  
*/
class IpChecksumSession
  extends Session {

  /**
  */
  public IpChecksumSession(State initialState) {
  
  //+ IpChecksumSession::IpChecksumSession(State)
      super(initialState);
      sides[Side.A].setMessenger(IpChecksumFromNetMessenger.instance);
      sides[Side.B].setMessenger(IpChecksumToNetMessenger.instance);
  //- IpChecksumSession::IpChecksumSession(State)
  }
  
} // IpChecksumSession

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
