/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  IpChecksumState
  Package: ip
  File:    IpChecksumState.java
*/

package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
  IpChecksumState
  
  Checks the validity of an IP packet
*/
class IpChecksumState
  extends Object
  implements State {

  /**
  */
  public static IpChecksumState instance = new IpChecksumState();;
  
  /**
    Calls the IPChecksumFromNetMessenger messenger's validChecksum(). If 
    the checksum is wrong, the packet is discarded
    
    
  */
  public void applyFromNet(Message message, Session session, Messenger messenger) {
  
  //+ IpChecksumState::applyFromNet(Message, Session, Messenger)
    IpChecksumFromNetMessenger msgr = (IpChecksumFromNetMessenger) messenger;
    if (!msgr.validChecksum(message)) {
      System.err.println("IP checksum failed. Datagram discarded.");
      ((IpChecksumSession)session).releaseMessage(message);
    }
    message.setMessenger(IpFragmentationFromNetMessenger.instance);
  //- IpChecksumState::applyFromNet(Message, Session, Messenger)
  }
  
  /**
    Calls the IpChecksumToNetMessenger messenger's calculateChecksum().
  */
  public void applyToNet(Message message, Session session, Messenger messenger) {
  
  //+ IpChecksumState::applyToNet(Message, Session, Messenger)
    IpChecksumToNetMessenger msgr = (IpChecksumToNetMessenger) messenger;
    msgr.calculateChecksum(message);
  //- IpChecksumState::applyToNet(Message, Session, Messenger)
  }
  
} // IpChecksumState

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
