/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpFragmentationFromNetMessenger (implementation)
    Package: ip
    File:    IpFragmentationFromNetMessenger.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpFragmentationFromNetMessenger
    
    Only provides the standard apply() method, that calls the state's
    applyFromNet() method.
    
    
*/
public class IpFragmentationFromNetMessenger
  extends IpMessenger {
    public static IpFragmentationFromNetMessenger instance = new IpFragmentationFromNetMessenger();

    public void apply(Message message, State state, Session session) {
    //+ IpFragmentationFromNetMessenger::apply(Message, State, Session)
      IpFragmentationState st = (IpFragmentationState) state;
      st.applyFromNet(message, session, this);
    //- IpFragmentationFromNetMessenger::apply(Message, State, Session)
    }

}; //IpFragmentationFromNetMessenger

