/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpHeaderFromNetMessenger (implementation)
    Package: ip
    File:    IpHeaderFromNetMessenger.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpHeaderFromNetMessenger
    
    Provides the method removeIpHeader() for use by IpHeaderState.
*/
public class IpHeaderFromNetMessenger
  extends IpMessenger {
    public static IpHeaderFromNetMessenger instance = new IpHeaderFromNetMessenger();

    /**
        This method is probably going to replace removeIpHeader(),
        effectively ignoring the existence of IpHeaderState.
    */
    public void apply(Message message, State state, Session session) {
    //+ IpHeaderFromNetMessenger::apply(Message, State, Session)
      IpHeaderState st = (IpHeaderState) state;
      st.applyFromNet(message, this);
    //- IpHeaderFromNetMessenger::apply(Message, State, Session)
    }

    /**
        Remove an IP header frame from message
    */
    public void removeIpHeader(Message message) {
    //+ IpHeaderFromNetMessenger::removeIpHeader(Message)
      // DEBUG:
      // IpStubMessenger.instance.printHeader(message);
      Object buffer = message.getContents();
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();

      int hlen = 5 * 4; // XXX No options yet
      int destIpAddr = getDestIpAddr(message);
      int totlen = getTotalLength(message);
      oob.setDestIpAddr(destIpAddr);
      oob.setDataLen(totlen - hlen);
      removeHeader(buffer, hlen);
    //- IpHeaderFromNetMessenger::removeIpHeader(Message)
    }

}; //IpHeaderFromNetMessenger

