/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpHeaderSession (implementation)
    Package: ip
    File:    IpHeaderSession.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
    IpHeaderSession
    
    Adds an IP header to outgoing packets and sets the 'protocol' field to
    match with the associated higher-level protocol. Removes the IP header
    frame from incoming packets.
*/
public class IpHeaderSession
  extends Session {

    protected int currDatagramId;
    public static int MAX_DATAGRAM_ID = 65535;

    public IpHeaderSession(State initialState) {
    //+ IpHeaderSession::IpHeaderSession(State)
      super(initialState);
      currDatagramId = 1;
      sides[Side.A].setMessenger(IpHeaderFromNetMessenger.instance);
      sides[Side.B].setMessenger(IpHeaderToNetMessenger.instance);
    //- IpHeaderSession::IpHeaderSession(State)
    }

    protected int getNextDatagramId() {
    //+ IpHeaderSession::getNextDatagramId( )
      if (currDatagramId >= MAX_DATAGRAM_ID)
	currDatagramId = 0;
      return ++currDatagramId; // note that the value is never 0
    //- IpHeaderSession::getNextDatagramId( )
    }

}; //IpHeaderSession

