/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpHeaderToNetMessenger (implementation)
    Package: ip
    File:    IpHeaderToNetMessenger.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpHeaderToNetMessenger
    
    Provides the method addIpHeader() for use by IpHeaderState.
    AddIpHeader() inserts a default TTL, among other things.
*/
public class IpHeaderToNetMessenger
  extends IpMessenger {
    public static IpHeaderToNetMessenger instance = new IpHeaderToNetMessenger();

    /**
        This method is probably going to replace the method addIpHeader(),
        effectively ignoring the existence of IpHeaderState altogether.
    */
    public void apply(Message message, State state, Session session) {
    //+ IpHeaderToNetMessenger::apply(Message, State, Session)
      ((IpHeaderState) state).applyToNet(message, session, this);
    //- IpHeaderToNetMessenger::apply(Message, State, Session)
    }

    /**
        Add an IP header frame to message and fill in the fixed values
    */
    public void addIpHeader(Message message) {
    //+ IpHeaderToNetMessenger::addIpHeader(Message)
      Object buffer = message.getContents();

      int hlen = 5 * 4; // XXX No options yet
      prependHeader(buffer, hlen);
    //- IpHeaderToNetMessenger::addIpHeader(Message)
    }

}; //IpHeaderToNetMessenger

