/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  IpProtocolAccessor
  Package: ip
  File:    IpProtocolAccessor.java
*/

package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
  IpProtocolAccessor
  
  
*/
class IpProtocolAccessor
  extends Object
  implements Accessor {

  /**
  */
  public Object getKey(Message message) {
  
  //+ IpProtocolAccessor::getKey(Message)
      Object buffer = message.getContents();
      IpMessenger msgr = (IpMessenger) message.getMessenger();
      return new Byte((byte) msgr.getByte(buffer, 9));
  //- IpProtocolAccessor::getKey(Message)
  }
  
  /**
    Writes the id of the higher level protocol to the PROTOCOL field of the
     IP header
  */
  public void setKey(Message message, Object key) {
  
  //+ IpProtocolAccessor::setKey(Message, Object)
      Object buffer = message.getContents();
      IpMessenger msgr = (IpMessenger) message.getMessenger();
      msgr.setByte(buffer, 9, ((Byte) key).byteValue());
  //- IpProtocolAccessor::setKey(Message, Object)
  }
  
  /**
  */
  public void unsetKey(Message message) {
  
  //+ IpProtocolAccessor::unsetKey(Message)
  //- IpProtocolAccessor::unsetKey(Message)
  }
  
} // IpProtocolAccessor

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
