/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  IpReassemblySession
  Package: ip
  File:    IpReassemblySession.java
*/

package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
  IpReassemblySession
  
  Ignores outgoing packets and unfragmented incoming packets. Incoming IP 
  fragments are temporarily stored until all fragments have arrived. The 
  fragments are then assembled and the resulting IP datagram forwarded to 
  the next conduit in the direction of the application layer.
*/
class IpReassemblySession
  extends Session {

  /**
  */
  protected IpReassemblyTable reassemblyTable;
  
  /**
  */
  public IpReassemblySession(State initialState) {
  
  //+ IpReassemblySession::IpReassemblySession(State)
      super(initialState);
      reassemblyTable = new IpReassemblyTable();
  //- IpReassemblySession::IpReassemblySession(State)
  }
  
} // IpReassemblySession

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
