/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  IpRoutingAccessor
  Package: ip
  File:    IpRoutingAccessor.java
*/

package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
  IpRoutingAccessor
  
  1. Gets the correct network interface IP address and Ethernet interface 
  number from the InterfaceTable.
  2. If the source IP address is empty, the retrieved network interface IP 
  address is put as the source IP address.
  3. Finally, the accessor returns the interface key to its mux.
  
*/
class IpRoutingAccessor
  extends Object
  implements Accessor {

  /**
  */
  public IpRoutingAccessor() {
  
  //+ IpRoutingAccessor::IpRoutingAccessor( )
  //- IpRoutingAccessor::IpRoutingAccessor( )
  }
  
  /**
  */
  public Object getKey(Message message) {
  
  //+ IpRoutingAccessor::getKey(Message)
    return ((TcpipOutOfBand) message.getOob()).getInterfaceId();
  //- IpRoutingAccessor::getKey(Message)
  }
  
  /**
  */
  public void setKey(Message message, Object key) {
  
  //+ IpRoutingAccessor::setKey(Message, Object)
    TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();
    oob.setInterfaceId((String) key);
  //- IpRoutingAccessor::setKey(Message, Object)
  }
  
  /**
  */
  public void unsetKey(Message message) {
  
  //+ IpRoutingAccessor::unsetKey(Message)
  //- IpRoutingAccessor::unsetKey(Message)
  }
  
} // IpRoutingAccessor

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
