/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpRoutingOnState (implementation)
    Package: ip
    File:    IpRoutingOnState.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
    IpRoutingOnState
    
    The RoutingSession is in this state when routing is enabled.
    
*/
public class IpRoutingOnState
  extends IpRoutingState {

  public static final IpRoutingOnState instance = new IpRoutingOnState();


    /**
        Calls the Messenger's destinationLocal() method which tells if the
        destination IP address belongs to this machine. If the destination
        is local, then the message is forwarded to the ReassemblySession
        right away.
        The IP TimeToLive is decremented by one. If it becomes zero, the
        packet is sent to the IcmpAdaptor.
        The messenger's setNextHopIp() method is called, and the packet is
        sent on its way to  the IpRoutingMux.
        
    */
    public void applyFromNet(Message message, Session session, Messenger messenger) {
    //+ IpRoutingOnState::applyFromNet(Message, Session, Messenger)
      message.setMessenger(IpRoutingToNetMessenger.instance);
      applyToNet(message, session, IpRoutingToNetMessenger.instance); 
    //- IpRoutingOnState::applyFromNet(Message, Session, Messenger)
    }

}; //IpRoutingOnState

