/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**

    File:    ArpModuleTest.java

    !!!!!!!!HANDMADE!!!!!!!

*/

// package fi.hut.tcm.jacob.tcpip.icmp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;
import fi.hut.tcm.jacob.tcpip.arp.*;
import fi.hut.tcm.jacob.tcpip.ethernet.*;
import java.util.Vector;
/**

  ArpModuleTest

*/

public class ArpModuleTest {
  
  // SimpleScheduler automatically starts travellerThread
  private final SimpleScheduler scheduler = SimpleScheduler.instance;

  public static void main(String[] argv) {

    if (argv.length != 2) {
      System.err.println("Usage: java ArpModuleTest <ownethernetaddr> <ownipaddr>");
      System.exit(1);
    }

    EthernetAddress myMac = new EthernetAddress(argv[0]);
    IpAddress myIp = new IpAddress(argv[1]);
    int myIpAddr = myIp.toInt();

    //    IpAddress otherAddr = new IpAddress("10.0.10.20");
    //     int otherIpAddr = otherAddr.toInt();

    // Instances

    Arp arpProtocol =
      new Arp(myMac);
    arpProtocol.addIpAddress(myIp);
    IpImpostorAdaptor ipAdap =
      new IpImpostorAdaptor();

    Vector filteredIps = new Vector();
    filteredIps.addElement(new IpAddress("130.233.45.26")); // clotam
    filteredIps.addElement(new IpAddress("130.233.45.255")); // broadcast
    filteredIps.addElement(new IpAddress("130.233.195.255")); // broadcast
    EthernetAdaptor ethAdap =
      new EthernetAdaptor( myMac, filteredIps, "/dev/le", 0 );

    try {

      // No sending yet, here we will connct the IP parts later.
      ipAdap.getSide(Side.A).attach(arpProtocol.getSide(Side.B));
      arpProtocol.getSide(Side.B).attach(ipAdap.getSide(Side.A));
      ethAdap.getSide(Side.A).attach(arpProtocol.getSide(Side.A));
      arpProtocol.getSide(Side.A).attach(ethAdap.getSide(Side.A));
    } catch (SideException e) {
      System.out.println("Host #" + " failed to initialize");
      System.exit(2);
    }

    try {
      System.out.println("Ready to answer ARP requests.");
      Thread.sleep(0);
    } catch (InterruptedException e) {
      System.out.println("INTERRUPTED!");
      System.exit(0);
    }
  }
}
