/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**

    File:    IcmpBounceAdaptor.java

    This is a simple adaptor that will send a packet, intact,
    back up to the ICMP protocol.

    This adaptor is used for simple module testing.

    This adaptor is handmade, based on the IcmpEchoAnswerAdaptor.

*/
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;
import fi.hut.tcm.jacob.tcpip.icmp.*;

/**
    IcmpBounceAdaptor
    
    
*/
public class IcmpBounceAdaptor
  extends Adaptor {

    public void adapt(Message message) {
    //+ IcmpBounceAdaptor::adapt(Message)

      message.setMessenger(IcmpChecksumFromNetMessenger.instance);
      // The following seems necessary
      MessageTransporter mt =
	MessageTransporter.newMessageTransporter(sides[Side.A].getAttached(), message);

      SimpleScheduler.instance.makeRunnable(mt);
      
      if(Icmp.DebugLevel > 3)
	System.out.println("Made new transporter in BounceAdaptor");
    //- IcmpEchoAnswerAdaptor::adapt(Message)
    }

}; //IcmpBounceAdaptor




