/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  XXX   %Z%%M% version %I% date:%G%
  Component:  UdpChecksumState
  Package: udp
  File:    UdpChecksumState.java
*/

package fi.hut.tcm.jacob.tcpip.udp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
  UdpChecksumState
  
  
*/
class UdpChecksumState
  extends Object
  implements State {

  /**
  */
  public static UdpChecksumState instance = new UdpChecksumState();
  
  /**
  */
  public void applyToNet(Message message, Session session, Messenger messenger) {
  //+ UdpChecksumState::applyToNet(Message, Session, Messenger)
      UdpChecksumToNetMessenger msgr = (UdpChecksumToNetMessenger) messenger;
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();
      UdpChecksumSession sess = (UdpChecksumSession) session;
      //TcpipRoutingTable rtbl = sess.routingTable;
      //TcpipInterfaceTable itbl = sess.interfaceTable;
      
      int destIpAddr = oob.getDestIpAddr();
      int srcIpAddr = oob.getSrcIpAddr();

      //TcpipRoutingEntry rentry = rtbl.get(destIpAddr);
      //TcpipInterfaceEntry ientry = itbl.get(rentry.getInterfaceId());
      //int srcIpAddr = ientry.getDefIpAddr();

      msgr.calculateChecksum(message, srcIpAddr, destIpAddr);
      // Unset messenger before the packet leaves the protocol:
      message.setMessenger(null);
  //- UdpChecksumState::applyToNet(Message, Session, Messenger)
  }
  
  /**
  */
  public void applyFromNet(Message message, Messenger messenger, Session session) {
  //+ UdpChecksumState::applyFromNet(Message, Messenger, Session)
    if(!((UdpChecksumFromNetMessenger) messenger).validChecksum(message))
      // Checksum check failed, discard the message.
      ((UdpChecksumSession)session).releaseMessage(message);
    else
      message.setMessenger(UdpHeaderFromNetMessenger.instance);
  //- UdpChecksumState::applyFromNet(Message, Messenger, Session)
  }
  
  /**
  */
  private UdpChecksumState() {
  //+ UdpChecksumState::UdpChecksumState( )
  //- UdpChecksumState::UdpChecksumState( )
  }
  
} // UdpChecksumState

// +*************** UNUSED CODE ***************
//+ UdpChecksumState::applyFromNet(Message, Messenger)
//- UdpChecksumState::applyFromNet(Message, Messenger)
// -*************** UNUSED CODE ***************
