/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  XXX   %Z%%M% version %I% date:%G%
  Component:  UdpHeaderState
  Package: udp
  File:    UdpHeaderState.java
*/

package fi.hut.tcm.jacob.tcpip.udp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
  UdpHeaderState
  
  
*/
class UdpHeaderState
  extends Object
  implements State {

  /**
  */
  public static UdpHeaderState instance = new UdpHeaderState();
  
  /**
  */
  public void applyToNet(Message message, Session session, Messenger messenger) {
  //+ UdpHeaderState::applyToNet(Message, Session, Messenger)
    UdpHeaderToNetMessenger msgr = (UdpHeaderToNetMessenger) messenger;
    TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();
    
    msgr.addUdpHeader(message);
    
    /* Debug:
    System.out.println("srcPort: "+oob.getSrcPort());
    System.out.println("dstPort: "+oob.getDestPort());
    System.out.println(" length: "+UtilMsgr.i.
		   getLength(message.getContents()));
		   */
    
    msgr.setSrcPort(message, oob.getSrcPort());
    msgr.setDestPort(message, oob.getDestPort());
    msgr.setUdpLength(message, UtilMsgr.i.
		      getLength(message.getContents()));
    
    message.setMessenger(UdpChecksumToNetMessenger.instance);

  //- UdpHeaderState::applyToNet(Message, Session, Messenger)
  }
  
  /**
  */
  public void applyFromNet(Message message, Messenger messenger) {
  //+ UdpHeaderState::applyFromNet(Message, Messenger)
    UdpHeaderFromNetMessenger msgr = (UdpHeaderFromNetMessenger) messenger;
    TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();
    
    oob.setSrcPort(msgr.getSrcPort(message));
    oob.setDestPort(msgr.getDestPort(message));
    
    msgr.removeUdpHeader(message);
  //- UdpHeaderState::applyFromNet(Message, Messenger)
  }
  
  /**
  */
  private UdpHeaderState() {
  //+ UdpHeaderState::UdpHeaderState( )
  //- UdpHeaderState::UdpHeaderState( )
  }
  
} // UdpHeaderState

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
