/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  XXX   %Z%%M% version %I% date:%G%
  Component:  UdpMessenger
  Package: udp
  File:    UdpMessenger.java
*/

package fi.hut.tcm.jacob.tcpip.udp;
import fi.hut.tcm.jacob.conduits.*;

/**
  UdpMessenger
  
  
*/
abstract class UdpMessenger
  extends BufferMessenger
  implements Messenger {

  /* ****************** Interprets ************************/
  
  /**
  */

  /* ***************End of Interprets *********************/
  
  /**
  */
  public final int getSrcPort(Message message) {
  //+ UdpMessenger::getSrcPort(Message)
    return getShort(message.getContents(),0);
  //- UdpMessenger::getSrcPort(Message)
  }
  
  /**
  */
  public abstract void apply(Message message, State state, Session session);
  
  /**
  */
  public final void setSrcPort(Message message, int port) {
  //+ UdpMessenger::setSrcPort(Message, int)
    setShort(message.getContents(),0,port);
  //- UdpMessenger::setSrcPort(Message, int)
  }
  
  /**
  */
  public final int getDestPort(Message message) {
  //+ UdpMessenger::getDestPort(Message)
    return getShort(message.getContents(),1);
  //- UdpMessenger::getDestPort(Message)
  }
  
  /**
  */
  public final void setDestPort(Message message, int port) {
  //+ UdpMessenger::setDestPort(Message, int)
    setShort(message.getContents(),1,port);
  //- UdpMessenger::setDestPort(Message, int)
  }
  
  /**
  */
  public final int getUdpLength(Message message) {
  //+ UdpMessenger::getUdpLength(Message)
    return getShort(message.getContents(),2);
  //- UdpMessenger::getUdpLength(Message)
  }
  
  /**
  */
  public final void setUdpLength(Message message, int len) {
  //+ UdpMessenger::setUdpLength(Message, int)
    setShort(message.getContents(),2,len);
  //- UdpMessenger::setUdpLength(Message, int)
  }
  
  /**
  */
  public final int getChecksum(Message message) {
  //+ UdpMessenger::getChecksum(Message)
    return getShort(message.getContents(),3);
  //- UdpMessenger::getChecksum(Message)
  }
  
  /**
  */
  public final void setChecksum(Message message, int csum) {
  //+ UdpMessenger::setChecksum(Message, int)
    setShort(message.getContents(),3,csum);
  //- UdpMessenger::setChecksum(Message, int)
  }
  
} // UdpMessenger

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
